// ExtListBox.cpp : implementation file
//

#include "stdafx.h"
#include "Modulist.h"
#include "titletip.h"
#include "ExtListBox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExtListBox

CExtListBox::CExtListBox()
: m_LastMouseMovePoint(0, 0) , m_nNoIndex(-1)
{
	m_pTitleTip = new CTitleTip;
	m_MenuItemID = 0;
	m_bMouseCaptured = FALSE;
	m_bAppActive = TRUE;
	EnableToolTips();
}

CExtListBox::~CExtListBox()
{
	delete m_pTitleTip;
}


BEGIN_MESSAGE_MAP(CExtListBox, CListBox)
	//{{AFX_MSG_MAP(CExtListBox)
	ON_WM_RBUTTONUP()
	ON_WM_MENUSELECT()
	ON_WM_MOUSEMOVE()
	ON_WM_DESTROY()
	ON_WM_KILLFOCUS()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_ACTIVATEAPP()
	ON_WM_RBUTTONDOWN()
	ON_WM_ACTIVATE()
	ON_WM_CAPTURECHANGED()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExtListBox message handlers

void CExtListBox::OnRButtonUp(UINT nFlags, CPoint point) 
{
	BOOL bOutside;
	UINT uiSelItem = ItemFromPoint(point,bOutside);

	if (!bOutside)
	{
		if (uiSelItem != (UINT)GetCurSel())
			SetCurSel(uiSelItem);

	    LPITEMIDLIST  pidl;
		LPSHELLFOLDER pDesktopFolder;
		LPSHELLFOLDER pFolder;
		OLECHAR       olePath[MAX_PATH];
		ULONG         chEaten;
		ULONG         dwAttributes;
		HRESULT       hr;
		

		char szPath[MAX_PATH];
		GetPath(GetCurSel(),szPath);
		char szFullFileName[MAX_PATH],szFullDir[MAX_PATH],szDir[MAX_PATH],szDrv[MAX_PATH],szFileName[MAX_PATH],szExt[MAX_PATH];
		_splitpath(szPath,szDrv,szDir,szFileName,szExt);
		sprintf(szFullDir,"%s%s",szDrv,szDir);
		sprintf(szFullFileName,"%s%s",szFileName,szExt);
		LPMALLOC ppMalloc;
		SHGetMalloc(&ppMalloc);

		//
		// Get a pointer to the Desktop's IShellFolder interface.
		//
		if (SUCCEEDED(SHGetDesktopFolder(&pDesktopFolder)))
		{
		 try
		 {

			//
			// IShellFolder::ParseDisplayName requires the file name be in
			// Unicode.
			//
			MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, szFullDir, -1,
								olePath, MAX_PATH);

			//
			// Convert the path to an ITEMIDLIST.
			//
			hr = pDesktopFolder->ParseDisplayName(GetParent()->GetSafeHwnd(),
														  NULL,
														  olePath,
														  &chEaten,
														  &pidl,
														  &dwAttributes);
			if (FAILED(hr))
				throw((long)-1);
			hr = pDesktopFolder->BindToObject(pidl,NULL,IID_IShellFolder,(VOID **)&pFolder);
			if (FAILED(hr))
				throw((long)-2);

			ppMalloc->Free((void*)pidl);
			//release the desktop folder object
			pDesktopFolder->Release();

			//
			// Convert the path to an ITEMIDLIST.
			//
			MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, szFullFileName, -1,
								olePath, MAX_PATH);
			hr = pFolder->ParseDisplayName(GetParent()->GetSafeHwnd(),
														  NULL,
														  olePath,
														  &chEaten,
														  &pidl,
														  &dwAttributes);
			if (FAILED(hr))
				throw((long)-3);
			//
			// pidl now contains a pointer to an ITEMIDLIST for .\readme.txt.
			// This ITEMIDLIST needs to be freed using the IMalloc allocator
			// returned from SHGetMalloc().
			//
			ClientToScreen(&point);
			DoTheMenuThing(m_hWnd,pFolder,pidl,&point);

			ppMalloc->Free((void*)pidl);
			pFolder->Release();
		 }
		 catch(long l)
		 {
			 TRACE ("Fehler beim Ermitteln der ItemIDList bzw. des Folders Code=%d\n",l);
			 return;
		 }
		}
	}
	CListBox::OnRButtonUp(nFlags, point);
}

BOOL CExtListBox::DoTheMenuThing (
	HWND hwnd, LPSHELLFOLDER lpsfParent, LPITEMIDLIST lpi, LPPOINT lppt)
{
	LPCONTEXTMENU lpcm;
	HRESULT hr;
	char szTemp [64];
	CMINVOKECOMMANDINFO cmi;
	DWORD dwAttribs = 0;
	int idCmd;
	HMENU hMenu;
	BOOL bSuccess = TRUE;

	hr = lpsfParent->GetUIObjectOf (
		hwnd,
		1, // get attributes for this many objects 
		(const struct _ITEMIDLIST **)&lpi,
		IID_IContextMenu,
		0,
		(LPVOID *)&lpcm);

	if (SUCCEEDED (hr)) 
	{
		hMenu = CreatePopupMenu ();

		if (hMenu)
		{
			// Get the context menu for the item.
			hr = lpcm->QueryContextMenu (hMenu, 0, 1, 0x7fff, CMF_EXPLORE);
			if (SUCCEEDED (hr))
			{
				CMenu AMenu;
				AMenu.Attach(hMenu);
				AMenu.AppendMenu(MF_SEPARATOR);
				AMenu.AppendMenu(MF_STRING,1001,"Modulinformationen");

				idCmd = TrackPopupMenu (
				hMenu, TPM_LEFTALIGN | TPM_RETURNCMD | TPM_RIGHTBUTTON, 
				lppt->x, lppt->y, 0, hwnd, NULL);

				switch (idCmd)
				{
				case 1001:
					AfxMessageBox("Noch nicht implementiert");
					break;
				default:
					if (idCmd) 
					{
						// Execute the command that was selected.
						cmi.cbSize = sizeof (CMINVOKECOMMANDINFO);
						cmi.fMask = 0;
						cmi.hwnd = hwnd;
						cmi.lpVerb = MAKEINTRESOURCE (idCmd - 1);
						cmi.lpParameters = NULL;
						cmi.lpDirectory = NULL;
						cmi.nShow = SW_SHOWNORMAL;
						cmi.dwHotKey = 0;
						cmi.hIcon = NULL;

						hr = lpcm->InvokeCommand (&cmi);
						if (! SUCCEEDED (hr)) 
						{
							wsprintf (szTemp, "InvokeCommand failed. hr = %lx", hr);
							AfxMessageBox (szTemp);
						}
					}
					break;
				}
			}

			else
				bSuccess = FALSE;

			DestroyMenu (hMenu);
		}

		else
			bSuccess = FALSE;

			lpcm->Release ();
	} 
	else
	{
		wsprintf (szTemp, "GetUIObjectOf failed! hr = %lx", hr);
		AfxMessageBox (szTemp);
		bSuccess = FALSE;
	}

	return bSuccess;
} 


void CExtListBox::OnMenuSelect(UINT nItemID, UINT nFlags, HMENU hSysMenu) 
{
	switch (nItemID)
	{
	case 1001: 
		m_MenuItemID = nItemID;
		TRACE ("OnMenuSelect ID 1001, nFlags = %d\n",nFlags);
		break;
	default:
		m_MenuItemID = 0;
		break;
	}
	CListBox::OnMenuSelect(nItemID, nFlags, hSysMenu);
	
	// TODO: Add your message handler code here
	
}

int CExtListBox::AddPath(LPCTSTR lpszItem, DWORD dwProcID)
{
	CString szFilename = GetDisplayString(lpszItem);
	int iRc = AddString(szFilename);
	ITEM_DATA * pData = new ITEM_DATA;
	pData->pszPath = strdup(lpszItem);
	pData->dwProcId = dwProcID;
	SetItemData(iRc,(DWORD)pData);
	return iRc;
}

CString CExtListBox::GetDisplayString(LPCTSTR lpszItem)
{
	char szDummy[MAX_PATH];
	char szFileName[MAX_PATH];
	char szExt[MAX_PATH];
	_splitpath(lpszItem,szDummy,szDummy,szFileName,szExt);
	CString strResult;
	strResult.Format("%s%s",szFileName,szExt);
	return strResult;
}

void CExtListBox::ResetContent()
{
	for (int Index = 0; Index<this->GetCount();Index++)
	{
		DeletePath(Index);
	}
	CListBox::ResetContent();
}

void CExtListBox::DeletePath(UINT Index)
{
	ITEM_DATA* pData = (ITEM_DATA*)GetItemData(Index);
	if (pData)
	{
		if (pData->pszPath)
			free(pData->pszPath);
		delete pData;
		SetItemData(Index,0);
	}
}

int CExtListBox::DeleteString(UINT Index)
{
	DeletePath(Index);
	return CListBox::DeleteString(Index);
}

int CExtListBox::GetPath(int nIndex, LPTSTR lpszBuffer)
{
	int iRc;
	ITEM_DATA *pData = (ITEM_DATA *)GetItemData(nIndex);
	if (pData && pData->pszPath)
	{
		iRc = strlen(pData->pszPath);
		strcpy(lpszBuffer,pData->pszPath);
	}

	return iRc;
}

int CExtListBox::GetPath(int nIndex, CString &szBuffer)
{
	int iRc = 0;
	ITEM_DATA *pData = (ITEM_DATA *)GetItemData(nIndex);
	if (pData && pData->pszPath)
	{
		szBuffer = CString(pData->pszPath);
	}

	return iRc;
}

DWORD CExtListBox::GetProcID(int nIndex)
{
	ITEM_DATA *pData = (ITEM_DATA *)GetItemData(nIndex);
	if (pData)
	{
		return (pData->dwProcId);
	}
	return 0;
}

BOOL CExtListBox::PreTranslateMessage(MSG* pMsg) 
{
    switch (pMsg->message)    
	{        
		case WM_RBUTTONDOWN:
        case WM_RBUTTONUP:        
		case WM_LBUTTONDOWN:
        case WM_LBUTTONUP:        
		case WM_LBUTTONDBLCLK:
        case WM_RBUTTONDBLCLK:
            // Make the active view because that is the default
            // behaviour caused by WM_MOUSEACTIVATE when NO TitleTip
            // is over this window.            
			AdjustTitleTip(m_nNoIndex);
            CFrameWnd* pFrameWnd = GetParentFrame();            
			if (pFrameWnd)
            {                
				BOOL bDone = FALSE;
                CWnd* pWnd = this;                
				while (!bDone)
                {                    
					pWnd = pWnd->GetParent();
                    if (!pWnd || pWnd == pFrameWnd)                    
					{
                        bDone = TRUE;                    
					}
                    else if (pWnd->IsKindOf(RUNTIME_CLASS(CView)))
                    {
                        pFrameWnd->SetActiveView((CView*)pWnd);
                        bDone = TRUE;                    
					}                
				}
            }            
			break;    
	}    	

	return CListBox::PreTranslateMessage(pMsg);
}

void CExtListBox::OnMouseMove(UINT nFlags, CPoint point) 
{
    if (point != m_LastMouseMovePoint && IsAppActive())    
	{
        m_LastMouseMovePoint = point;        
		int nIndexHit = m_nNoIndex;
        CRect ClientRect;        
		GetClientRect(ClientRect);
        if (ClientRect.PtInRect(point))        
		{            // Hit test.
            for (int n = 0; nIndexHit == m_nNoIndex && n < GetCount(); n++)
            {                
				CRect ItemRect;
                GetItemRect(n, ItemRect);
                if (ItemRect.PtInRect(point))                
				{
                    nIndexHit = n;                    
				}            
			}        
		}
        AdjustTitleTip(nIndexHit);    
	}	
	CListBox::OnMouseMove(nFlags, point);
}


int CExtListBox::GetIdealItemRect(int nIndex, LPRECT lpRect)
{
    // Calculate the ideal rect for an item. The ideal rect is dependent
    // on the length of the string. This only works for regular 
    // (non owner-draw)listboxes.    
	ASSERT(lpRect);    
	ASSERT(nIndex >= 0);
    DWORD dwStyle = GetStyle();
    int    nStatus = GetItemRect(nIndex, lpRect);    
    if (nStatus != LB_ERR && !(dwStyle & LBS_OWNERDRAWFIXED) && 
        !(dwStyle & LBS_OWNERDRAWVARIABLE))    
	{        
		CString strItem;
        GetPath(nIndex, strItem);        
		if (!strItem.IsEmpty())        
		{
            // Calulate the ideal text length.            
			CClientDC DC(this);
            CFont* pOldFont = DC.SelectObject(GetFont());
            CSize ItemSize = DC.GetTextExtent(strItem);
            DC.SelectObject(pOldFont);
            // Take the maximum of regular width and ideal width.
            const int cxEdgeSpace = 2;
            lpRect->right = max(lpRect->right, 
                lpRect->left + ItemSize.cx + (cxEdgeSpace * 2));        
		}    
	}
    else    
	{
        TRACE("Owner-draw listbox detected - override CExtListBox::GetIdeaItemRect()\n");
    }    
	return nStatus;
}

void CExtListBox::AdjustTitleTip(int nNewIndex)
{
    if (!::IsWindow(m_pTitleTip->m_hWnd))    
	{
        VERIFY(m_pTitleTip->Create(this));    
	}    
	if (nNewIndex == m_nNoIndex)
    {        
		m_pTitleTip->Hide();    
	}    
	else    
	{        
		CRect IdealItemRect;
        GetIdealItemRect(nNewIndex, IdealItemRect);        
		CRect ItemRect;
        GetItemRect(nNewIndex, ItemRect);        
		if (FALSE) //ItemRect == IdealItemRect)
        {            
			m_pTitleTip->Hide();        
		}        
		else        
		{
            // Adjust the rect for being near the edge of screen.
            ClientToScreen(IdealItemRect);
            int nScreenWidth = ::GetSystemMetrics(SM_CXFULLSCREEN);
            if (IdealItemRect.right > nScreenWidth)            
			{
                IdealItemRect.OffsetRect(nScreenWidth - IdealItemRect.right, 0);
            }            
			if (IdealItemRect.left < 0)            
			{
                IdealItemRect.OffsetRect(-IdealItemRect.left, 0);            
			}
            m_pTitleTip->Show(IdealItemRect, nNewIndex);          
		}    
	}
    
	if (m_pTitleTip->IsWindowVisible())    
	{
        // Make sure we capture mouse so we can detect when to turn off 
        // title tip.        
		if (!m_bMouseCaptured && GetCapture() != this)
        {            
			CaptureMouse();        
		}    
	}    
	else    
	{
        // The tip is invisible so release the mouse.
        if (m_bMouseCaptured)        
		{            
			VERIFY(ReleaseCapture());
            m_bMouseCaptured = FALSE;        
		}    
	}
}

void CExtListBox::CaptureMouse()
{    
	ASSERT(!m_bMouseCaptured);
    CPoint Point;    
	VERIFY(GetCursorPos(&Point));    
	ScreenToClient(&Point);
    m_LastMouseMovePoint = Point;    
	SetCapture();    
	m_bMouseCaptured = TRUE;
}

void CExtListBox::OnDestroy() 
{
    AdjustTitleTip(m_nNoIndex);    
	m_pTitleTip->DestroyWindow();

	CListBox::OnDestroy();
}

void CExtListBox::OnKillFocus(CWnd* pNewWnd) 
{
	CListBox::OnKillFocus(pNewWnd);
}

void CExtListBox::OnLButtonDown(UINT nFlags, CPoint point) 
{
    // Temporarily disable mouse capturing because the base class may 
    // capture the mouse.    
	if (m_bMouseCaptured)    
	{        
		VERIFY(ReleaseCapture());
        m_bMouseCaptured = FALSE;    
	}

    CListBox::OnLButtonDown(nFlags, point);   
	
	if (m_pTitleTip->IsWindowVisible())
    {        
		m_pTitleTip->InvalidateRect(NULL);        
		if (this != GetCapture())
        {            
			CaptureMouse();        
		}    
	}
}

void CExtListBox::OnLButtonUp(UINT nFlags, CPoint point) 
{
    if (this != GetCapture() && m_pTitleTip->IsWindowVisible())    
	{
        CaptureMouse();    
	}	

	CListBox::OnLButtonUp(nFlags, point);
}


BOOL CExtListBox::IsAppActive()
{
	CWnd * pToplevelParent = AfxGetMainWnd();
	CWnd *pActiveWnd = GetActiveWindow();
	if (!pActiveWnd || !pToplevelParent)
		return FALSE;
	return (pActiveWnd->IsChild(pToplevelParent) || pActiveWnd->m_hWnd == pToplevelParent->m_hWnd);
}

void CExtListBox::OnActivateApp(BOOL bActive, HTASK hTask) 
{
	CListBox::OnActivateApp(bActive, hTask);
	
	m_bAppActive = bActive;	
}

void CExtListBox::OnRButtonDown(UINT nFlags, CPoint point) 
{
    // Temporarily disable mouse capturing because the base class may 
    // capture the mouse.    
	if (m_bMouseCaptured)    
	{        
		VERIFY(ReleaseCapture());
        m_bMouseCaptured = FALSE;    
	}

	CListBox::OnRButtonDown(nFlags, point);

	if (m_pTitleTip->IsWindowVisible())
    {        
		m_pTitleTip->InvalidateRect(NULL);        
		if (this != GetCapture())
        {            
			CaptureMouse();        
		}    
	}

}

void CExtListBox::OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized) 
{
	CListBox::OnActivate(nState, pWndOther, bMinimized);
	
}

void CExtListBox::OnCaptureChanged(CWnd *pWnd) 
{
	if (this != pWnd)
		AdjustTitleTip(m_nNoIndex);
	CListBox::OnCaptureChanged(pWnd);
}
