// ModulistDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Modulist.h"
#include "titletip.h"
#include "ModulistDlg.h"
#include <winperf.h>   // for Windows NT 
#include <tlhelp32.h>  // for Windows 95 
#include "common.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

typedef BOOL (WINAPI *TH32_PROCESS) (HANDLE hSnapShot, LPPROCESSENTRY32 lppe);
typedef BOOL (WINAPI *TH32_MODULE) (HANDLE hSnapShot, LPMODULEENTRY32 lpme);
typedef HANDLE (WINAPI *TH32_CREATESNAPSHOT) (DWORD dwFlags, DWORD th32ProcessId);
typedef BOOL (WINAPI *PSAPI_ENUM_PROCESS_MODULES)(HANDLE hProcess, HMODULE *lphModule,DWORD cb, LPDWORD lpcbNeeded);
typedef BOOL (WINAPI *PSAPI_ENMUM_PROCESSES)(DWORD *lpidProcess, DWORD cb, DWORD *cbneeded);
typedef DWORD(WINAPI *PSAPI_GET_MODULE_BASENAME)(HANDLE hProcess,HMODULE hModule,LPTSTR lpBaseName,DWORD nSize);
#ifdef _UNICODE
const char szGetModuleBaseName[] = "GetModuleBaseNameW";
const char szGetModuleFileNameEx[] = "GetModuleFileNameExW";
#else
const char szGetModuleBaseName[] = "GetModuleBaseNameA";
const char szGetModuleFileNameEx[] = "GetModuleFileNameExA";
#endif

static TH32_PROCESS pProcess32First = NULL, pProcess32Next = NULL;
static TH32_MODULE pModule32First = NULL, pModule32Next = NULL;
static TH32_CREATESNAPSHOT pCreateToolhelp32Snapshot = NULL;
static PSAPI_ENUM_PROCESS_MODULES pEnumProcessModules = NULL;
static PSAPI_ENMUM_PROCESSES pEnumProcesses = NULL;
static PSAPI_GET_MODULE_BASENAME pGetModuleBaseName = NULL;
static PSAPI_GET_MODULE_BASENAME pGetModuleFileNameEx = NULL;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_WM_CONTEXTMENU()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CModulistDlg dialog

CModulistDlg::CModulistDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CModulistDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CModulistDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CModulistDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CModulistDlg)
	DDX_Control(pDX, IDC_BUTTON2, m_SaveButton);
	DDX_Control(pDX, IDCANCEL, m_CancelButton);
	DDX_Control(pDX, IDC_BUTTON1, m_RefreshButton);
	DDX_Control(pDX, IDC_LIST2, m_ModuleList);
	DDX_Control(pDX, IDC_LIST1, m_ProcessList);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CModulistDlg, CDialog)
	//{{AFX_MSG_MAP(CModulistDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnRefresh)
	ON_LBN_SELCHANGE(IDC_LIST1, OnSelchangeList1)
	ON_WM_SIZE()
	ON_WM_CONTEXTMENU()
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CModulistDlg message handlers

BOOL CModulistDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_version.dwOSVersionInfoSize= sizeof(OSVERSIONINFO);
	m_hSysHelp = NULL;
	
	if (!GetVersionEx(&m_version)){
		m_version.dwOSVersionInfoSize = 0; 
	}
	else
	{
		if (m_version.dwPlatformId == VER_PLATFORM_WIN32_NT)
		{ // Windows NT PSAPI Dll laden und Funktionsaddressen fr div. PSAPI Fkt. ermitteln
			m_hSysHelp = LoadLibrary("psapi.dll");
			pEnumProcessModules = (PSAPI_ENUM_PROCESS_MODULES)GetProcAddress(m_hSysHelp,"EnumProcessModules");
			pEnumProcesses = (PSAPI_ENMUM_PROCESSES)GetProcAddress(m_hSysHelp,"EnumProcesses");
			pGetModuleBaseName= (PSAPI_GET_MODULE_BASENAME)GetProcAddress(m_hSysHelp,szGetModuleBaseName);
			pGetModuleFileNameEx = (PSAPI_GET_MODULE_BASENAME)GetProcAddress(m_hSysHelp,szGetModuleFileNameEx);
		}
		else // Windows 95 -> Funktionsaddressen fr Toolhelp32 Fkt. ermitteln
		{
			m_hSysHelp = LoadLibrary("kernel32.dll");
			pCreateToolhelp32Snapshot = (TH32_CREATESNAPSHOT)GetProcAddress(m_hSysHelp,"CreateToolhelp32Snapshot");
			pProcess32First = (TH32_PROCESS)GetProcAddress(m_hSysHelp,"Process32First");
			pProcess32Next = (TH32_PROCESS)GetProcAddress(m_hSysHelp,"Process32Next");
			pModule32First = (TH32_MODULE)GetProcAddress(m_hSysHelp,"Module32First");
			pModule32Next = (TH32_MODULE)GetProcAddress(m_hSysHelp,"Module32Next");
		}
	}

	BOOL bProcInterfaceFound;
	m_RefreshButton.EnableWindow(bProcInterfaceFound = ProcInterfaceFound());
	if (bProcInterfaceFound)
		Refresh();

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// Prft, ob die fr das jeweilige Betriebssystem bentigten Hilfsfunktionen 
// gefunden wurden. Das sind unter Win NT diverse PSAPI Funktionen und unter Win 95
// die Toolhelp32 Funktionen aus der Kernel32 Dll
BOOL CModulistDlg::ProcInterfaceFound()
{
	BOOL bRc = (m_version.dwOSVersionInfoSize != 0) ;
	if (m_version.dwPlatformId == VER_PLATFORM_WIN32_NT)
		bRc &= pEnumProcesses && pEnumProcessModules && pGetModuleBaseName;
	else
		bRc &= pCreateToolhelp32Snapshot && pProcess32First && pProcess32Next;
	return bRc;
}

// Hilfsfunktion, die aus einer Prozess ID unter Windows NT den vollstndigen Pfad des 
// EXE Files ermittelt
CString PSAPI_GetProcessName( DWORD processID )
{
    char szProcessName[MAX_PATH] = "unknown";    // Get a handle to the process.
    HANDLE hProcess = OpenProcess( PROCESS_QUERY_INFORMATION |
                                   PROCESS_VM_READ,
                                   FALSE, processID );
    // Get the process name.    
	if ( hProcess )    
	{        
		HMODULE hMod;
        DWORD cbNeeded;
        if ( pEnumProcessModules( hProcess, &hMod, sizeof(hMod), 
             &cbNeeded) )        
		{
            pGetModuleFileNameEx( hProcess, hMod, szProcessName, 
                               sizeof(szProcessName) );        
		}    
	}
    CloseHandle( hProcess );
    // Print the process name and identifier.
    return CString(szProcessName);
}

// Die Liste der gerade laufenden Prozesse aufbauen. 
// Dies erfolgt mit Hilfe der (zuvor dynamisch geladenen) PSAPI Dll
BOOL CModulistDlg::BuildNTProcessList()
{
	DWORD aProcesses[MAX_PROCESSES], cbNeeded, cProcesses;    unsigned int i;
	if ( !pEnumProcesses( aProcesses, sizeof(aProcesses), &cbNeeded ) )
		return FALSE;    

	cProcesses = cbNeeded / sizeof(DWORD); // Calculate how many process identifiers were returned.
	for ( i = 0; i < cProcesses; i++ ) // Nach Winhelp suchen
	{
		CString szLine = PSAPI_GetProcessName( aProcesses[i] );
		int Index = m_ProcessList.AddPath(szLine,aProcesses[i]);
	}
	return TRUE;
}

// Die Liste der gerade laufenden Prozesse aufbauen. 
// Dies erfolgt mit Hilfe der Toolhelp32 Funktionen aus dem Windows 95 Kernel
BOOL CModulistDlg::BuildWin95ProcessList()
{
	PROCESSENTRY32 procEntry;
	procEntry.dwSize = sizeof(PROCESSENTRY32);
	HANDLE hSnap = pCreateToolhelp32Snapshot(TH32CS_SNAPPROCESS,0);
	if (hSnap > 0)
	{
		if (pProcess32First(hSnap,&procEntry))
		{
			while (pProcess32Next(hSnap,&procEntry))
			{
//				char szFileName[MAX_PATH], szExt[MAX_PATH], szDummy[MAX_PATH];
//				_splitpath(procEntry.szExeFile,szDummy,szDummy,szFileName,szExt);
//				CString szLine;
//				szLine.Format("%s.%s ",szFileName, szExt);
				int Index = m_ProcessList.AddPath(procEntry.szExeFile,procEntry.th32ProcessID);
			}
		}
		CloseHandle(hSnap);
	}
	return TRUE;
}

// Die Modulliste zu einem Prozess mit der ID PID unter Windows 95 aufbauen
// Dies erfolgt mit Hilfe der (zuvor dynamisch ermittelten) Toolhelp32 Funktionen
// aus dem Windows 95 Kernel
BOOL CModulistDlg::BuildWin95ModuleList(DWORD PID)
{
	MODULEENTRY32 modEntry;
	modEntry.dwSize = sizeof(MODULEENTRY32);
	HANDLE hSnap = pCreateToolhelp32Snapshot(TH32CS_SNAPMODULE,PID);
	if (hSnap > 0)
	{
		if (pModule32First(hSnap,&modEntry))
		{
			while (pModule32Next(hSnap,&modEntry))
			{
				m_ModuleList.AddPath(modEntry.szExePath);
			}
		}
		CloseHandle(hSnap);
	}
	return TRUE;
}

// Die Modulliste zu einem Prozess mit der ID PID unter Windows NT aufbauen
// Dies erfolgt mit Hilfe der (zuvor dynamisch geladenen) PSAPI Dll
BOOL CModulistDlg::BuildWinNTModuleList(DWORD PID)
{
    char szProcessName[MAX_PATH] = "unknown";    // Get a handle to the process.
    HANDLE hProcess = OpenProcess( PROCESS_QUERY_INFORMATION |
                                   PROCESS_VM_READ,
                                   FALSE, PID );
    // Get the process name.    
	if ( hProcess )    
	{        
		HMODULE hMod[MAX_MODULES];
        DWORD cbNeeded,cModules;
        if ( pEnumProcessModules( hProcess, hMod, sizeof(hMod), 
             &cbNeeded) )        
		{
			cModules = cbNeeded / sizeof (DWORD);
			for (unsigned int i = 1; i< cModules; i++)
			{
				char szLine[MAX_PATH];
				pGetModuleFileNameEx(hProcess,hMod[i],szLine,MAX_PATH);
				//szLine.Format("%s (PID = %d)",GetModuleFileName( aProcesses[i] ), aProcesses[i] );
				m_ModuleList.AddPath(szLine);
			}
		}    
	}
    CloseHandle( hProcess );
    // Print the process name and identifier.
	return TRUE;
}

// Listen aktualisieren:
void CModulistDlg::Refresh()
{
	m_ProcessList.ResetContent();
	m_ModuleList.ResetContent();
	if (ProcInterfaceFound())
	{
		if (m_version.dwPlatformId == VER_PLATFORM_WIN32_NT)
		{
			BuildNTProcessList();
		}
		else // Win 95:
		{
			BuildWin95ProcessList();
		}
	}
	m_ProcessList.SetCurSel(0);
	if (m_version.dwPlatformId == VER_PLATFORM_WIN32_NT)
		BuildWinNTModuleList(m_ProcessList.GetProcID(0));
	else
		BuildWin95ModuleList(m_ProcessList.GetProcID(0));
}


void CModulistDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CModulistDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CModulistDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CModulistDlg::OnRefresh() 
{
	Refresh();	
}

// Wenn ein anderer Prozess gewhlt wird -> neue Modullist aufbauen
void CModulistDlg::OnSelchangeList1() 
{
	m_ModuleList.ResetContent();
	if (m_ProcessList.GetCurSel()>=0)
	{
		DWORD dwPID = m_ProcessList.GetProcID(m_ProcessList.GetCurSel()); //atoi(szPID+6);
		if (m_version.dwPlatformId == VER_PLATFORM_WIN32_NT)
			BuildWinNTModuleList(dwPID);
		else
			BuildWin95ModuleList(dwPID);
	}
}


void CModulistDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	const int gap = 7; // Abstand zw. beiden Listen
	CRect Rect0;
	
	if (::IsWindow(m_ProcessList.m_hWnd))
	{
		CRect Rect;
		m_RefreshButton.GetClientRect(&Rect);
		int yBottom = cy-Rect.Height() -3*gap;
		int xMid = (int)(cx/2);
		m_ProcessList.MoveWindow(gap,gap,xMid-gap,yBottom);
		m_ModuleList.MoveWindow(xMid+gap,gap,xMid-gap,yBottom);
		CRect LstRect;
		m_ModuleList.GetWindowRect(&LstRect);
		m_RefreshButton.GetWindowRect(&Rect);
		Rect.top = LstRect.bottom+gap;
		ScreenToClient(&Rect);
		m_RefreshButton.SetWindowPos(NULL,Rect.left,Rect.top,0,0,SWP_NOSIZE);
		m_CancelButton.GetWindowRect(&Rect);
		Rect.top = LstRect.bottom+gap;
		ScreenToClient(&Rect);
		m_CancelButton.SetWindowPos(NULL,Rect.left,Rect.top,0,0,SWP_NOSIZE);
		m_SaveButton.GetWindowRect(&Rect);
		Rect.top = LstRect.bottom+gap;
		Rect.left = LstRect.left;
		ScreenToClient(&Rect);
		m_SaveButton.SetWindowPos(NULL,Rect.left,Rect.top,0,0,SWP_NOSIZE);
	}
}

void CModulistDlg::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	// TODO: Add your message handler code here
	
}

// Hiermit kann die Modulliste (mit Versionsnummern)des gerade ausgewhlten Prozesses als ASCII Datei 
// gespeichert werden, was zum spteren Vergleich mit einem anderen System ganz ntzlich 
// sein kann, um z. B. festzustellen, was evtl. veraltet ist.
void CModulistDlg::OnButton2() 
{
	CFileDialog Dlg(FALSE,"txt","Modules.Txt");
	if (Dlg.DoModal() == IDOK)
	{
	 try
	 {
		CStdioFile File(Dlg.GetPathName(),CFile::modeCreate|CFile::modeWrite);
		char szText[300],szPath[MAX_PATH];
		m_ProcessList.GetText(m_ProcessList.GetCurSel(),szPath);
		sprintf(szText,"Module zum Prozess: %s\n\n",szPath);
		File.WriteString(szText);
		for (int i =0;i<m_ModuleList.GetCount();i++)
		{
			m_ModuleList.GetPath(i,szPath);

			DWORD dwDummy,dwSize = GetFileVersionInfoSize(szPath,&dwDummy);
			VOID *fileInfo = malloc(dwSize);
			
			char *szProductName= NULL ,*szProductVersion = NULL, *szCopyright = NULL,
					*pszProductDescription= NULL;
			char szProductDescr[200];
			IMAGE_OPTIONAL_HEADER32 FileHeader;
			
			DumpOptionalHeader(szPath, FileHeader);
			
			if (GetFileVersionInfo(szPath,0,dwSize,fileInfo))
			{
				UINT dwLength;
				VOID* pBuffer;
				char szBuffer[200];
				char szTableID[] = "040904b0";

				DWORD dwValue;
				WORD wValueLen;
				if (VerQueryValue(fileInfo,TEXT("\\VarFileInfo\\Translation"),&pBuffer,&dwLength))
				{
					BYTE * pBytes = (BYTE *) pBuffer;
					wValueLen = MakePtr(WORD, pBytes, 2);
					memcpy((void*)&dwValue,pBuffer,sizeof(DWORD));
					dwValue = pBytes[2] + pBytes[3] * 0x100 + 
								pBytes[0] * 0x10000 + pBytes[1] * 0x1000000;
					sprintf(szTableID,"%08x",dwValue); 
				}

				if (VerQueryValue(fileInfo,TEXT("\\"),&pBuffer,&dwLength))
				{
					//TEST
					VS_FIXEDFILEINFO* pBytes = (VS_FIXEDFILEINFO*) pBuffer;
				}

				sprintf(szBuffer,"\\StringFileInfo\\%s\\ProductName",szTableID);
				if (VerQueryValue(fileInfo,TEXT(szBuffer),&pBuffer,&dwLength))
				{
					szProductName = (char *)pBuffer;
				}

				sprintf(szBuffer,"\\StringFileInfo\\%s\\ProductVersion",szTableID);
				if (VerQueryValue(fileInfo,TEXT(szBuffer),&pBuffer,&dwLength))
				{
					szProductVersion= (char *)pBuffer;
				}
				else
				{
					sprintf(szBuffer,"%d.%02d",FileHeader.MajorImageVersion,FileHeader.MinorImageVersion);
					szProductVersion = szBuffer;
				}
				if (szProductName && szProductVersion)
				{
					sprintf(szProductDescr,"%s, Version %s",szProductName,szProductVersion);
				}


				sprintf(szBuffer,"\\StringFileInfo\\%s\\LegalCopyRight",szTableID);
				if (VerQueryValue(fileInfo,TEXT(szBuffer),&pBuffer,&dwLength))
				{
					szCopyright= (char *)pBuffer;
				}

				sprintf(szBuffer,"\\StringFileInfo\\%s\\FileDescription",szTableID);
				if (VerQueryValue(fileInfo,TEXT(szBuffer),&pBuffer,&dwLength))
				{
					pszProductDescription = (char *)pBuffer;
				}
			}

			if (pszProductDescription)
				sprintf(szText,"%s\t(V%s, %s)\n",szPath,szProductVersion,pszProductDescription);
			else
				sprintf(szText,"%s\t(V%s)\n",szPath,szProductVersion);
			File.WriteString(szText);
		}
	 }
	 catch(CFileException e)
	 {
		 // Fehlerbeh. ...
	 }
	}

	
}

void CModulistDlg::DumpOptionalHeader(LPSTR filename, IMAGE_OPTIONAL_HEADER32 &Header)
{
	HANDLE hFile;
	HANDLE hFileMapping;
	LPVOID lpFileBase;
	PIMAGE_DOS_HEADER dosHeader;
	PIMAGE_NT_HEADERS pNTHeader;

	hFile = CreateFile(filename, GENERIC_READ, FILE_SHARE_READ, NULL,
						OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
					
	if ( hFile == INVALID_HANDLE_VALUE )
	{
		TRACE("Couldn't open file with CreateFile()\n");
		return;
	}

	hFileMapping = CreateFileMapping(hFile, NULL, PAGE_READONLY, 0, 0, NULL);
	if ( hFileMapping == 0 )
	{
		CloseHandle(hFile);
		TRACE("Couldn't open file mapping with CreateFileMapping()\n");
		return;
	}

	lpFileBase = MapViewOfFile(hFileMapping, FILE_MAP_READ, 0, 0, 0);
	if ( lpFileBase == 0 )
	{
		CloseHandle(hFileMapping);
		CloseHandle(hFile);
		TRACE("Couldn't map view of file with MapViewOfFile()\n");
		return;
	}

	TRACE("Dump of file %s\n\n", filename);
	
	dosHeader = (PIMAGE_DOS_HEADER)lpFileBase;
	if ( dosHeader->e_magic == IMAGE_DOS_SIGNATURE )
	{
		DWORD base = (DWORD)dosHeader;
	
		pNTHeader = MakePtr( PIMAGE_NT_HEADERS, dosHeader, dosHeader->e_lfanew );

		if (pNTHeader->FileHeader.SizeOfOptionalHeader == sizeof(Header))
			memcpy((void*)&Header,(void*)&pNTHeader->OptionalHeader,sizeof(Header));
		else
			memset((void*)&Header,0,sizeof(Header));
	}
	else
		TRACE("unrecognized file format\n");

	UnmapViewOfFile(lpFileBase);
	CloseHandle(hFileMapping);
	CloseHandle(hFile);
}
